package cl.axg.hls_player;
package cl.axg.exoplayer;


import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.Dialog;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Color;
import android.media.Image;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.SeekBar;
import android.widget.TextView;

import androidx.core.content.ContextCompat;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.exoplayer2.ExoPlaybackException;
import com.google.android.exoplayer2.Player;
import com.google.android.exoplayer2.SimpleExoPlayer;
import com.google.android.exoplayer2.source.MediaSource;
import com.google.android.exoplayer2.source.ProgressiveMediaSource;
import com.google.android.exoplayer2.source.dash.DashMediaSource;
import com.google.android.exoplayer2.source.hls.HlsMediaSource;
import com.google.android.exoplayer2.trackselection.DefaultTrackSelector;
import com.google.android.exoplayer2.ui.PlayerView;
import com.google.android.exoplayer2.upstream.DefaultHttpDataSource;
import com.google.android.exoplayer2.upstream.DefaultHttpDataSourceFactory;
import com.google.android.exoplayer2.util.Util;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.security.SecureRandom;
import java.security.cert.X509Certificate;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Calendar;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

public class ZappingActivity extends Activity {

    private static final String TAG = "ZappingActivity";

    private  PlayerView playerView;
    private  SimpleExoPlayer player;
    private  Handler mHandler = new Handler();
    private  Runnable mRunnable;
    private  boolean hayError;
    static  int playVideoAtIndex=0;
    private ImageView btnCloseVideo = null;
    private ImageView btnPreviousVideo = null;
    private ImageView btnNextVideo = null;
    private ImageView btnInfoEPGVideo = null;
    private ArrayList<Video> canales;
    private ArrayList<EPG> epgList ;
    private EPG currentEPG = null;
    private String urlEPG = null;



    public void closeImgBtnOnClick(View v)
    {
        this.finish();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        canales = new ArrayList<Video>();

        Intent intent = getIntent();

        String jsonCanales = intent.getStringExtra("canales");
        playVideoAtIndex = intent.getIntExtra("playVideoAtIndex",0);
        urlEPG = intent.getStringExtra("urlEPG");

        try {
            JSONArray jsonArray = new JSONArray(jsonCanales);

            for (int i=0; i < jsonArray.length(); i++) {
                JSONObject jsonObject = jsonArray.optJSONObject(i);
                String titulo       = jsonObject.getString("titulo");
                String descripcion       = jsonObject.getString("descripcion");
                String   imagenPath  = jsonObject.getString("imagenPath");
                int   numeroCanal  = Integer.parseInt(jsonObject.getString("numeroCanal"));
                int   studio  = Integer.parseInt(jsonObject.getString("studio"));
                String linkReproductor  = jsonObject.getString("linkReproductor");

                final Video video = new Video( titulo, descripcion, imagenPath,    numeroCanal,   studio,      linkReproductor );

                canales.add(video);
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }


        setContentView(R.layout.activity_zapping);
        ignoreSSL();
        setUp();

    }

    public void closeinfoEPGVideoClick(View arg0)
    {
        View layout_epg = (View)findViewById(R.id.epg);
        layout_epg.setVisibility(View.INVISIBLE);
        View txtDescripcion = (View)findViewById(R.id.txtDescripcion);
        txtDescripcion.setVisibility(View.INVISIBLE);

        View epg_descripcion = (View)findViewById(R.id.epg_bottom);
        epg_descripcion.setVisibility(View.INVISIBLE);


        btnCloseVideo.setVisibility(View.VISIBLE);
        btnInfoEPGVideo.setVisibility(View.VISIBLE);
        btnNextVideo.setVisibility(View.VISIBLE);
        btnPreviousVideo.setVisibility(View.VISIBLE);


    }
    public void nextVideoClick(View arg0) {

        final int longitudArreglo = canales.size()-1;


        if(playVideoAtIndex == longitudArreglo){
            playVideoAtIndex=0;
            initEPG();
            prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
            player.setPlayWhenReady(true);
            hayError = false;
        }else{

            playVideoAtIndex+=1;


            initEPG();
            prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
            player.setPlayWhenReady(true);
            hayError = false;
        }



        handleSSLHandshake();
        RequestQueue queue = Volley.newRequestQueue(this);
        String url = urlEPG.replace("STUDIO", String.valueOf(canales.get(playVideoAtIndex).getStudio()));
        Log.d(TAG,"url consulta STUDIO: "+url);

        // Request a string response from the provided URL.
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        JSONObject jsonObject = null;
                        epgList = new ArrayList<EPG>();

                        try {
                            jsonObject = new JSONObject(response);
                            JSONArray jsonArray = jsonObject.getJSONArray("epg");
                            for (int i=0; i < jsonArray.length(); i++) {
                                JSONObject item = jsonArray.optJSONObject(i);

                                EPG epg = new EPG(item.getString("titulo"),item.getString("fecha_ini"),item.getString("fecha_fin"),item.getString("run"));
                                epgList.add(epg);
                            }
                            if(epgList.size() == jsonArray.length()){

                                ArrayList<EPG> ee = new ArrayList<EPG>();

                                long now = System.currentTimeMillis();
                                for ( EPG item:epgList )
                                {

                                    String hora_inicio_1000 = new java.text.SimpleDateFormat("HH:mm:ss").format(new java.util.Date(item.getHoraInicio()  * 1000));


                                    Calendar date1 = Calendar.getInstance();
                                    date1.set(Calendar.HOUR_OF_DAY, date1.getTime().getHours() );
                                    date1.set(Calendar.MINUTE, date1.getTime().getMinutes() );
                                    date1.set(Calendar.SECOND, 0);

                                    String[] parts = hora_inicio_1000.split(":");
                                    Calendar date2 = Calendar.getInstance();
                                    date2.set(Calendar.HOUR_OF_DAY, Integer.parseInt(parts[0]));
                                    date2.set(Calendar.MINUTE, Integer.parseInt(parts[1]));
                                    date2.set(Calendar.SECOND, 0);



                                    if (date1.before(date2)) {
                                        //  System.out.println(date1.getTime()+" vs "+date2.getTime());
                                        // System.out.println("Not yet at the limit");
                                    }else{

                                        System.out.println("limit: "+item.getTitulo());
                                        ee.add(item);
                                    }
                                }
                                currentEPG = ee.get(ee.size()-1);
                                System.out.println("VIDEO ACTUAL ES: "+currentEPG.getTitulo());




                                updateProgressBar();
                                TextView txtTitulo =  findViewById(R.id.txtCurrentPrograma);
                                TextView txtProximoTitulo =  findViewById(R.id.txtProximoTitulo);
                                TextView txtHoraInicio =  findViewById(R.id.txtHoraInicio);
                                TextView txtHoraFin =  findViewById(R.id.txtHoraFin);

                                EPG epgCurrent = getCurrentEPGFromList();
                                txtTitulo.setText(epgCurrent.getTitulo());
                                txtProximoTitulo.setText(getNextEPGFromList().getTitulo());
                                txtHoraInicio.setText(epgCurrent.getHoraInicioFormato());
                                txtHoraFin.setText(epgCurrent.getHoraFinFormato());

                            }


                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.d(TAG, "That didn't work!"+error.toString());
            }
        });

// Add the request to the RequestQueue.
        queue.add(stringRequest);

    }

    public void previousVideoClick(View arg0)
    {
        if(playVideoAtIndex > 0){
        playVideoAtIndex-=1;

        prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
        player.setPlayWhenReady(true);
        hayError = false;

    }else{
            playVideoAtIndex =canales.size()-1;
            prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
            player.setPlayWhenReady(true);
            hayError = false;
        }



        handleSSLHandshake();
        RequestQueue queue = Volley.newRequestQueue(this);
        String url = urlEPG.replace("STUDIO", String.valueOf(canales.get(playVideoAtIndex).getStudio()));
        Log.d(TAG,"url consulta STUDIO: "+url);

        // Request a string response from the provided URL.
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        JSONObject jsonObject = null;
                        epgList = new ArrayList<EPG>();

                        try {
                            jsonObject = new JSONObject(response);
                            JSONArray jsonArray = jsonObject.getJSONArray("epg");
                            for (int i=0; i < jsonArray.length(); i++) {
                                JSONObject item = jsonArray.optJSONObject(i);

                                EPG epg = new EPG(item.getString("titulo"),item.getString("fecha_ini"),item.getString("fecha_fin"),item.getString("run"));
                                epgList.add(epg);
                            }
                            if(epgList.size() == jsonArray.length()){

                                ArrayList<EPG> ee = new ArrayList<EPG>();

                                long now = System.currentTimeMillis();
                                for ( EPG item:epgList )
                                {

                                    String hora_inicio_1000 = new java.text.SimpleDateFormat("HH:mm:ss").format(new java.util.Date(item.getHoraInicio()  * 1000));


                                    Calendar date1 = Calendar.getInstance();
                                    date1.set(Calendar.HOUR_OF_DAY, date1.getTime().getHours() );
                                    date1.set(Calendar.MINUTE, date1.getTime().getMinutes() );
                                    date1.set(Calendar.SECOND, 0);

                                    String[] parts = hora_inicio_1000.split(":");
                                    Calendar date2 = Calendar.getInstance();
                                    date2.set(Calendar.HOUR_OF_DAY, Integer.parseInt(parts[0]));
                                    date2.set(Calendar.MINUTE, Integer.parseInt(parts[1]));
                                    date2.set(Calendar.SECOND, 0);



                                    if (date1.before(date2)) {
                                        //  System.out.println(date1.getTime()+" vs "+date2.getTime());
                                        // System.out.println("Not yet at the limit");
                                    }else{

                                        System.out.println("limit: "+item.getTitulo());
                                        ee.add(item);
                                    }
                                }
                                currentEPG = ee.get(ee.size()-1);
                                System.out.println("VIDEO ACTUAL ES: "+currentEPG.getTitulo());




                                updateProgressBar();
                                TextView txtTitulo =  findViewById(R.id.txtCurrentPrograma);
                                TextView txtProximoTitulo =  findViewById(R.id.txtProximoTitulo);
                                TextView txtHoraInicio =  findViewById(R.id.txtHoraInicio);
                                TextView txtHoraFin =  findViewById(R.id.txtHoraFin);

                                EPG epgCurrent = getCurrentEPGFromList();
                                txtTitulo.setText(epgCurrent.getTitulo());
                                txtProximoTitulo.setText(getNextEPGFromList().getTitulo());
                                txtHoraInicio.setText(epgCurrent.getHoraInicioFormato());
                                txtHoraFin.setText(epgCurrent.getHoraFinFormato());

                            }


                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.d(TAG, "That didn't work!"+error.toString());
            }
        });

// Add the request to the RequestQueue.
        queue.add(stringRequest);

    }
    private void setUp() {

        initializePlayer();
        initControls();
        initEPG();
    }

      private void initializePlayer() {
        playerView = this.findViewById(R.id.playerViewZapping);
          playerView.getVideoSurfaceView().setOnClickListener(view -> {
              if (playerView.isControllerVisible()) {
                  // Do something if controls are visible
                  playerView.hideController();


                  Log.e("TOUCH", "hideController!");

                  View layout_epg = (View)findViewById(R.id.epg);
                  layout_epg.setVisibility(View.VISIBLE);
                  View txtDescripcion = (View)findViewById(R.id.txtDescripcion);
                  txtDescripcion.setVisibility(View.VISIBLE);

                  View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                  epg_descripcion.setVisibility(View.VISIBLE);

                  View viewControl = (View)findViewById(R.id.viewControl);
                  viewControl.setBackgroundColor(Color.TRANSPARENT);


              } else {
                  // Do something else if controls are not showing
                  playerView.showController();

                  View someView = findViewById(R.id.viewControl);
                  someView.setBackgroundResource( R.drawable.exoplayer_bottom);

                  View layout_epg = (View)findViewById(R.id.epg);
                  layout_epg.setVisibility(View.INVISIBLE);

                  View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                  epg_descripcion.setVisibility(View.INVISIBLE);





                  btnInfoEPGVideo.setVisibility(View.VISIBLE);
                  btnCloseVideo.setVisibility(View.VISIBLE);
                  btnNextVideo.setVisibility(View.VISIBLE);
                  btnPreviousVideo.setVisibility(View.VISIBLE);

                  Log.e("TOUCH", "showController!");
              }
          });
        playerView.requestFocus();
        if(mHandler!=null)
            mHandler.removeMessages(0);
        DefaultTrackSelector trackSelector = new DefaultTrackSelector(this);
        trackSelector.setParameters(trackSelector.buildUponParameters()
                .setMaxAudioChannelCount(1)
        );
        player = new SimpleExoPlayer.Builder(this).setTrackSelector(trackSelector).build();
        playerView.setPlayer(player);
        playerView.setShowBuffering(PlayerView.SHOW_BUFFERING_ALWAYS);
        player.addListener(new Player.EventListener() {
            @Override
            public void onPlayerError(ExoPlaybackException error) {
                mHandler.postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        hayError = true;
                        pause();
                        reproducir();
                    }
                }, 1000 * 10);
            }

            @Override
            public void onPlayerStateChanged(boolean playWhenReady, int playbackState) {
                if(playbackState==Player.STATE_ENDED){
                    reproducir();
                }
            }
        });

        player.setPlayWhenReady(true);
        play(player);
    }

    public void pause(){
        player.setPlayWhenReady(false);
        hayError = false;
    }


    public void play(SimpleExoPlayer player){

        prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
        player.setPlayWhenReady(true);
        hayError = false;
    }

    public void reproducir(){

        prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
        player.setPlayWhenReady(true);
        hayError = false;
    }
    private void prepareMediaForPlaying(Uri mediaSourceUri) {

        DefaultHttpDataSourceFactory dataSourceFactory = new DefaultHttpDataSourceFactory(
                Util.getUserAgent(this, "VideoPlayerGlue"),
                DefaultHttpDataSource.DEFAULT_CONNECT_TIMEOUT_MILLIS,
                DefaultHttpDataSource.DEFAULT_READ_TIMEOUT_MILLIS,
                true);
        MediaSource    mediaSource = getMediaSource(mediaSourceUri , dataSourceFactory);
        player.prepare(mediaSource);
        player.setPlayWhenReady(true);

    }
    private MediaSource getMediaSource(Uri uri,DefaultHttpDataSourceFactory dataSourceFactory){
        String path = uri.getPath();

        String[] extension = path.split("\\.");
        int largo = extension.length;
        if(largo>1){
            switch (extension[largo-1].toUpperCase()){
                case "MPD":
                    return new DashMediaSource
                            .Factory(dataSourceFactory)
                            .createMediaSource(uri);
                case "M3U8":
                    return new HlsMediaSource
                            .Factory(dataSourceFactory)
                            .createMediaSource(uri);


            }
        }
        return new ProgressiveMediaSource.Factory(dataSourceFactory).
                createMediaSource(uri);
    }


    private void releasePlayer() {
        if (player != null) {
            player.release();
            player = null;
        }
    }
    private void pausePlayer() {
        if (player != null) {
            player.setPlayWhenReady(false);
            player.getPlaybackState();
        }
    }
    private void resumePlayer() {
        if (player != null) {
            player.setPlayWhenReady(true);
            player.getPlaybackState();
        }
    }


    /**
     * Enables https connections
     */
    @SuppressLint("TrulyRandom")
    public static void handleSSLHandshake() {
        try {
            TrustManager[] trustAllCerts = new TrustManager[]{new X509TrustManager() {
                public X509Certificate[] getAcceptedIssuers() {
                    return new X509Certificate[0];
                }

                @Override
                public void checkClientTrusted(X509Certificate[] certs, String authType) {
                }

                @Override
                public void checkServerTrusted(X509Certificate[] certs, String authType) {
                }
            }};

            SSLContext sc = SSLContext.getInstance("SSL");
            sc.init(null, trustAllCerts, new SecureRandom());
            HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
            HttpsURLConnection.setDefaultHostnameVerifier(new HostnameVerifier() {
                @Override
                public boolean verify(String arg0, SSLSession arg1) {
                    return true;
                }
            });
        } catch (Exception ignored) {
        }
    }
    public String getURL(){
        return canales.get(playVideoAtIndex).getLinkReproductor();
    }


    public void btnInfoEPGVideoClick(View arg0)
    {

        handleSSLHandshake();
        RequestQueue queue = Volley.newRequestQueue(this);
         String url = urlEPG.replace("STUDIO", String.valueOf(canales.get(playVideoAtIndex).getStudio()));
        Log.d(TAG,"url consulta STUDIO: "+url);

        // Request a string response from the provided URL.
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url,
                new Response.Listener<String>() {
                    @Override
                    public void onResponse(String response) {
                        JSONObject jsonObject = null;
                        epgList = new ArrayList<EPG>();

                        try {
                            jsonObject = new JSONObject(response);
                            JSONArray jsonArray = jsonObject.getJSONArray("epg");
                            for (int i=0; i < jsonArray.length(); i++) {
                                JSONObject item = jsonArray.optJSONObject(i);

                                EPG epg = new EPG(item.getString("titulo"),item.getString("fecha_ini"),item.getString("fecha_fin"),item.getString("run"));
                                epgList.add(epg);
                            }
                            if(epgList.size() == jsonArray.length()){

                                ArrayList<EPG> ee = new ArrayList<EPG>();

                                long now = System.currentTimeMillis();
                                for ( EPG item:epgList )
                                {

                                    String hora_inicio_1000 = new java.text.SimpleDateFormat("HH:mm:ss").format(new java.util.Date(item.getHoraInicio()  * 1000));


                                    Calendar date1 = Calendar.getInstance();
                                    date1.set(Calendar.HOUR_OF_DAY, date1.getTime().getHours() );
                                    date1.set(Calendar.MINUTE, date1.getTime().getMinutes() );
                                    date1.set(Calendar.SECOND, 0);

                                    String[] parts = hora_inicio_1000.split(":");
                                    Calendar date2 = Calendar.getInstance();
                                    date2.set(Calendar.HOUR_OF_DAY, Integer.parseInt(parts[0]));
                                    date2.set(Calendar.MINUTE, Integer.parseInt(parts[1]));
                                    date2.set(Calendar.SECOND, 0);



                                    if (date1.before(date2)) {
                                        //  System.out.println(date1.getTime()+" vs "+date2.getTime());
                                        // System.out.println("Not yet at the limit");
                                    }else{

                                        System.out.println("limit: "+item.getTitulo());
                                        ee.add(item);
                                    }
                                }
                                currentEPG = ee.get(ee.size()-1);
                                System.out.println("VIDEO ACTUAL ES: "+currentEPG.getTitulo());




                                updateProgressBar();
                                TextView txtTitulo =  findViewById(R.id.txtCurrentPrograma);
                                TextView txtProximoTitulo =  findViewById(R.id.txtProximoTitulo);
                                TextView txtHoraInicio =  findViewById(R.id.txtHoraInicio);
                                TextView txtHoraFin =  findViewById(R.id.txtHoraFin);

                                EPG epgCurrent = getCurrentEPGFromList();
                                txtTitulo.setText(epgCurrent.getTitulo());
                                txtProximoTitulo.setText(getNextEPGFromList().getTitulo());
                                txtHoraInicio.setText(epgCurrent.getHoraInicioFormato());
                                txtHoraFin.setText(epgCurrent.getHoraFinFormato());

                                View layout_epg = (View)findViewById(R.id.epg);
                                layout_epg.setVisibility(View.VISIBLE);
                                View txtDescripcion = (View)findViewById(R.id.txtDescripcion);
                                txtDescripcion.setVisibility(View.VISIBLE);
                                View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                                epg_descripcion.setVisibility(View.VISIBLE);

                                btnInfoEPGVideo.setVisibility(View.INVISIBLE);
                                btnCloseVideo.setVisibility(View.INVISIBLE);
                                btnNextVideo.setVisibility(View.VISIBLE);
                                btnPreviousVideo.setVisibility(View.VISIBLE);

                            }


                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.d(TAG, "That didn't work!"+error.toString());
            }
        });

// Add the request to the RequestQueue.
        queue.add(stringRequest);
    }
    /**
     * Update timer on seekbar
     * */
    public void updateProgressBar() {
        mHandler.postDelayed(mUpdateTimeTask, 100);
    }

    /**
     * Background Runnable thread
     * */
    private Runnable mUpdateTimeTask = new Runnable() {
        public void run() {
            ProgressBar seekBar =  findViewById(R.id.seekbar);

            int valor = 0;
            try {
                valor = getCurrentEPGFromList().getPercentageLeft();
            } catch (ParseException e) {
                e.printStackTrace();
            }
            seekBar.setProgress( valor );
            Log.d("PROGRESO","progreso es: "+valor);

            // Running this thread after 100 milliseconds
            mHandler.postDelayed(this, 100);
        }
    };

    private EPG getCurrentEPGFromList()
    {
        return  currentEPG;
    }

    private EPG getNextEPGFromList()
    {
        if(epgList.size() == epgList.indexOf(currentEPG)+1){
            return  epgList.get(0);
        }else{
            return epgList.get(epgList.indexOf(currentEPG)+1);
        }


    }

    /**
     * When user starts moving the progress handler
     * */

    private void  initEPG(){
        Video video   = canales.get(playVideoAtIndex);

        new DownloadImageTask(findViewById(R.id.imgCanal))
                .execute(video.getImagenPath());

        TextView txtNumeroCanal =  findViewById(R.id.txtNumeroCanal);
        TextView txtDescripcion =  findViewById(R.id.txtDescripcion);


        txtNumeroCanal.setText(video.getNumeroCanal());

        txtDescripcion.setText(video.geDescripcion());
    }

    private void initControls(){

        View layout_epg = (View)findViewById(R.id.epg);
        layout_epg.setVisibility(View.INVISIBLE);
        View txtDescripcion = (View)findViewById(R.id.txtDescripcion);
        txtDescripcion.setVisibility(View.INVISIBLE);
        View epg_descripcion = (View)findViewById(R.id.epg_bottom);
        epg_descripcion.setVisibility(View.INVISIBLE);
        View viewControl = (View)findViewById(R.id.viewControl);
        viewControl.setBackgroundColor(Color.TRANSPARENT);

        btnCloseVideo = findViewById(R.id.btnCloseVideo);
        btnPreviousVideo = findViewById(R.id.btnPreviousVideo);
        btnNextVideo = findViewById(R.id.btnNextVideo);
        btnInfoEPGVideo = findViewById(R.id.btnInfoEPGVideo);

    }
    @Override
    protected void onPause() {
        super.onPause();
        pausePlayer();
        if (mRunnable != null) {
            mHandler.removeCallbacks(mRunnable);
        }
    }
    @Override
    protected void onRestart() {
        super.onRestart();
        resumePlayer();
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
        releasePlayer();
    }


    private void ignoreSSL(){
        try {
            TrustManager[] victimizedManager = new TrustManager[]{

                    new X509TrustManager() {

                        public X509Certificate[] getAcceptedIssuers() {

                            return new X509Certificate[0];
                        }

                        @SuppressLint("TrustAllX509TrustManager")
                        @Override
                        public void checkClientTrusted(X509Certificate[] certs, String authType) {
                        }

                        @SuppressLint("TrustAllX509TrustManager")
                        @Override
                        public void checkServerTrusted(X509Certificate[] certs, String authType) {
                        }
                    }
            };

            SSLContext sc = SSLContext.getInstance("SSL");
            sc.init(null, victimizedManager, new SecureRandom());
            HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
            HttpsURLConnection.setDefaultHostnameVerifier(new HostnameVerifier() {
                @SuppressLint("BadHostnameVerifier")
                @Override
                public boolean verify(String s, SSLSession sslSession) {
                    return true;
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        // ignore orientation/keyboard change
        super.onConfigurationChanged(newConfig);
    }

    @Override
    public void onBackPressed() {
        Log.d("CDA", "onBackPressed Called");
        super.onBackPressed();
    }

}