//
//  ViewController.swift
//  VideoApp
//
//  Created by Vasil Nunev on 11/07/2017.
//  Copyright © 2017 nunev. All rights reserved.
//

import AVKit
import UIKit
import AVFoundation
import Foundation

class ViewController_AVPlayer_List: UIViewController {
     
    var playVideoIndex:Int = 0
    var jsonCanales:String = ""
    
    private var player: AVQueuePlayer?
    private var queuePlayer: AVPlayerLayer?
    private var isPlayed = true
    private var frameQueuePlayer:CGRect?
    private var frameView:CGRect?
    private  var btnNext = UIButton()
    private  var btnInfoEPG = UIButton()
    private  var btnPreview = UIButton()
    private  var btnClose = UIButton()
    // private  var  routePickerView = AVRoutePickerView()
    private  var activityView :  UIActivityIndicatorView?
    private var isLandscapeLeft : UIInterfaceOrientation = .landscapeLeft
    private var viewTopEPG : UIView = UIView()
    private var viewBottomEPG : UIView = UIView()
    private var  txtNumeroCanal  : UITextField  = UITextField()
    private var  imagen_canal  : UIImageView  = UIImageView()
    private var  programa_actual_nombre : UILabel  = UILabel()
    private var  programa_horario_inicio  : UILabel  = UILabel()
    private var  programa_horario_fin  : UILabel  = UILabel()
    private var  programa_proximo_nombre  : UILabel  = UILabel()
    private var  programa_actual  : UILabel  = UILabel()
    private var  progressBar  : UIProgressView  = UIProgressView()
    private var  descripcion_canal  : UILabel  = UILabel()
    
    
    private var list:Array<Epg> = []
    private var listCanales:Array<VideoModel> = []
    
    
    
    
    //MARK: eventos del ciclo de vida del controlador
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
    }
    override func viewWillTransition(to size: CGSize, with coordinator: UIViewControllerTransitionCoordinator) {
        super.viewWillTransition(to: size, with: coordinator)
        if UIDevice.current.orientation.isLandscape {
            
            
            print("Landscape")
            self.queuePlayer?.videoGravity = AVLayerVideoGravity.resizeAspectFill
            
            //  self.queuePlayer?.frame = CGRect(x: 0, y: 0, width: 700, height:375)
            
            self.queuePlayer?.frame = self.frameQueuePlayer!
        } else {
            print("Portrait")
            // self.queuePlayer?.frame = CGRect(x: 0, y: 0, width: 380, height:200)
            self.queuePlayer?.frame = self.frameQueuePlayer!
            self.view.frame  = self.frameView!
            //self.view.frame = CGRect(x:0, y: 200, width: (self.view.frame.size.height), height: (self.view.frame.size.width))
        }
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        self.navigationController?.setNavigationBarHidden(true, animated: true)
        self.navigationController?.setToolbarHidden(true, animated: true)
        let value = UIInterfaceOrientation.landscapeLeft.rawValue
        UIDevice.current.setValue(value, forKey: "orientation")
        
        self.modalPresentationStyle = .fullScreen
        
    }
    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
        player?.pause() // 1. pause the player to stop it
        queuePlayer?.player = nil // 2. set the playerLayer's player to nil
        queuePlayer?.removeFromSuperlayer() // 3 remove the playerLayer from it's superLayer
        
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        buildJSONToEPG()
        startDemoVideo(canales: self.listCanales, playVideoIndex : self.playVideoIndex)
        buildButtons()
    }
    
   func buildJSONToEPG()
   {
        
        do{
            if let json =    jsonCanales.data(using: String.Encoding.utf8){
                if let canales = try JSONSerialization.jsonObject(with: json, options: .allowFragments) as? [[String:Any]] {
                    
                    for canal in canales{
                        
                        let studio = canal["studio"] as! Int
                        let titulo = canal["titulo"] as! String
                        let imagenPath = canal["imagenPath"] as! String
                        let descripcion = canal["descripcion"] as! String
                        let numeroCanal = canal["numeroCanal"] as! Int
                        let linkReproductor = canal["linkReproductor"] as! String
                        
                        let video:VideoModel =  VideoModel(studio: studio, titulo: titulo, imagenPath: imagenPath, descripcion: descripcion, numeroCanal: numeroCanal, linkReproductor: linkReproductor)
                        self.listCanales.append(video)
                    }
                }
            }
        }catch {
            print(error.localizedDescription)
        }
    }
    //MARK: inicializar reproductor con los canales para hacer zapping
    private func startDemoVideo(canales: Array<VideoModel> , playVideoIndex : Int) {
        player = AVQueuePlayer()
        queuePlayer = AVPlayerLayer(player: player)
        
        
        guard let queuePlayer = queuePlayer else { fatalError("Error creating player layer") }
        
        queuePlayer.frame = self.view.bounds
        self.frameQueuePlayer =  queuePlayer.frame
        
        queuePlayer.backgroundColor = UIColor.black.cgColor
        
        //        self.view.frame = CGRect(x: 0, y: 0, width: (self.view.frame.size.height), height: (self.view.frame.size.width))
        
        
        self.frameView =    self.view.frame
        
        self.view.layer.addSublayer(queuePlayer)
        
        
        delayWithSeconds(10) {
            
            if(self.viewBottomEPG.isHidden == false){
                self.btnPreview.isHidden = false
                self.btnNext.isHidden = false
            }else{
                self.btnClose.isHidden = true
                self.btnNext.isHidden = true
                self.btnPreview.isHidden = true
                self.btnInfoEPG.isHidden = true
            }
            // self.routePickerView.isHidden = true
        }
        
        let item : VideoModel = canales[playVideoIndex]
        let url = URL(string: item.linkReproductor)
        let newItem = AVPlayerItem(url: url!)
        self.player?.replaceCurrentItem(with: newItem)
        
        DispatchQueue.main.async {
            self.addObserverPlayerItem()
            
            self.player?.play()
        }
        
    }
    
    
    
    
    //MARK: Agregar observadores al reproductor
    private func addObserverPlayerItem(){
        if let playerItem = self.player?.currentItem{
            playerItem.addObserver(self, forKeyPath: "playbackBufferEmpty", options: .new, context: nil)
            playerItem.addObserver(self, forKeyPath: "playbackLikelyToKeepUp", options: .new, context: nil)
            playerItem.addObserver(self, forKeyPath: "playbackBufferFull", options: .new, context: nil)
            playerItem.addObserver(self, forKeyPath: "duration", options: [.new, .initial], context: nil)
            self.player?.addObserver(self, forKeyPath: #keyPath(AVPlayer.currentItem.status), options: [.new, .initial], context: nil)
            self.player?.addObserver(self, forKeyPath: #keyPath(AVPlayer.status), options: [.new, .initial], context: nil)
            
        }
    }
    //MARK: resultados de los observadores en el reproductor
    override public func observeValue(forKeyPath keyPath: String?, of object: Any?, change: [NSKeyValueChangeKey : Any]?, context: UnsafeMutableRawPointer?) {
        
        guard let currentItem = self.player!.currentItem else {return}
        
        if object is AVPlayerItem {
            switch keyPath {
                case "duration":
                    let interval = CMTime(seconds: 10, preferredTimescale: CMTimeScale(NSEC_PER_SEC))
                    let mainQueue = DispatchQueue.main
                    _ = self.player!.addPeriodicTimeObserver(forInterval: interval, queue: mainQueue, using: { [weak self] time in
                        
                        print("time "+(self?.getTimeString(from: currentItem.currentTime()))!)
                        
                        // print(currentItem.currentTime())
                    })
                
                case "playbackBufferEmpty":
                    // Show loader
                    self.showActivityIndicatory()
                
                case "playbackLikelyToKeepUp":
                    // Hide loader
                    self.activityView!.stopAnimating()
                    print(" self.activityIndicator?.stopAnimating()")
                
                case "playbackBufferFull":
                    // Hide loader
                    self.activityView!.stopAnimating()
                    print(" self.activityIndicator?.stopAnimating()")
                case #keyPath(AVPlayer.currentItem.status):
                    
                    let newStatus: AVPlayerItem.Status
                    if let newStatusAsNumber = change?[NSKeyValueChangeKey.newKey] as? NSNumber {
                        newStatus = AVPlayerItem.Status(rawValue: newStatusAsNumber.intValue)!
                    } else {
                        newStatus = .unknown
                    }
                    if newStatus == .failed {
                        NSLog("SA Detected Error: \(String(describing: self.player?.currentItem?.error?.localizedDescription)), error: \(String(describing: self.player?.currentItem?.error))")
                }
                case #keyPath(AVPlayer.status):
                    print()
                case .none:
                    self.activityView!.stopAnimating()
                    print(" self.activityIndicator?.stopAnimating()")
                case .some(_):
                    self.activityView!.stopAnimating()
                    print(" self.activityIndicator?.stopAnimating()")
            }
        }
    }
    
    // MARK: construir y dibujar botones en el reproductor
    private func buildButtons() {
           
        let canal:VideoModel = listCanales[self.playVideoIndex]
         print(canal)
        
          viewTopEPG = UIView(frame: CGRect(x: 0,  y: 0, width:  self.view.frame.maxX , height:  (self.view.frame.maxY/4)))
        
        let colorTop =  UIColor(red: 0.00, green: 0.00, blue: 0.00, alpha: 1.00).cgColor
        let colorBottom = UIColor(red: 0.55, green: 0.52, blue: 0.52, alpha:  0.2).cgColor
        
        let gradientLayer: CAGradientLayer = CAGradientLayer()
        gradientLayer.colors = [colorTop, colorBottom]
        gradientLayer.locations = [0.0, 1.0]
        gradientLayer.frame = viewTopEPG.frame
        
        
        let caja_cuadrada_componente_numero_canal = UIView(frame: CGRect(x: 0,  y: 0, width: 80.00, height: viewTopEPG.frame.height))
        caja_cuadrada_componente_numero_canal.backgroundColor = .black
        
        self.txtNumeroCanal =   UITextField(frame: CGRect(x: 0, y: 0, width: 80.00, height: viewTopEPG.frame.height));
        self.txtNumeroCanal.text = String(canal.numeroCanal)
        
        self.txtNumeroCanal.textColor = .white
        self.txtNumeroCanal.font = UIFont.boldSystemFont(ofSize: 35.0)
        self.txtNumeroCanal.textAlignment = .center
        caja_cuadrada_componente_numero_canal.addSubview(txtNumeroCanal )
        
        
        
        let caja_cuadrada_componente_imagen_canal = UIView(frame: CGRect(x: 80,  y: 0, width: 80.00, height: viewTopEPG.frame.height))
        
        self.imagen_canal = UIImageView(frame: CGRect(x: 0, y: 0, width: 80.00, height: viewTopEPG.frame.height))
        let url_imagen_canal = URL(string: canal.imagenPath)
        if let data = try? Data(contentsOf: url_imagen_canal!)
        {
            let image: UIImage = UIImage(data: data)!
            self.imagen_canal.image = image;
        }else{
            print("error SSL imagen ")
        }
        caja_cuadrada_componente_imagen_canal.addSubview(self.imagen_canal)
        
        
        
        let programacion_titulos_actual = UIView(frame: CGRect(x: 170,  y: 10, width:  self.view.frame.maxX , height:  (self.view.frame.maxY/4)))
        
        self.programa_actual.text  = "AHORA"
        self.programa_actual.textColor = .white
        self.programa_actual.textAlignment = .center
        self.programa_actual.font = UIFont.boldSystemFont(ofSize: 10.0)
        
        
        self.programa_actual_nombre.text  = "Tierra Adentro"
        self.programa_actual_nombre.textColor = .white
        self.programa_actual_nombre.textAlignment = .center
        self.programa_actual_nombre.font = UIFont.boldSystemFont(ofSize: 15.0)
        
        
        if #available(iOS 9.0, *)
        {
            //Stack View
            let stackView_programa_actual   = UIStackView()
            stackView_programa_actual.axis  = NSLayoutConstraint.Axis.vertical
            stackView_programa_actual.distribution  = UIStackView.Distribution.equalSpacing
            stackView_programa_actual.alignment = UIStackView.Alignment.top
            stackView_programa_actual.addArrangedSubview(programa_actual)
            stackView_programa_actual.addArrangedSubview(programa_actual_nombre)
            stackView_programa_actual.translatesAutoresizingMaskIntoConstraints = false
            programacion_titulos_actual.addSubview(stackView_programa_actual )
        } else {
            // Fallback on earlier versions
            print("No soporta stackView_programa_actual ")
        }
        
        
        let programacion_titulos_proximo = UIView(frame: CGRect(x: 170,  y: 50, width:  self.view.frame.maxX , height:  (self.view.frame.maxY/4)))
        
        
        let programa_proximo = UILabel()
        programa_proximo.text  = "PRÓXIMO"
        programa_proximo.textColor = .gray
        programa_proximo.textAlignment = .center
        programa_proximo.font = UIFont.boldSystemFont(ofSize: 10.0)
        
        self.programa_proximo_nombre = UILabel()
        self.programa_proximo_nombre.text  = "Viva el lunes"
        self.programa_proximo_nombre.textColor = .gray
        self.programa_proximo_nombre.textAlignment = .center
        self.programa_proximo_nombre.font = UIFont.boldSystemFont(ofSize: 15.0)
        
        
        if #available(iOS 9.0, *)
        {
            //Stack View
            let stackView_programa_proximo   = UIStackView()
            stackView_programa_proximo.axis  = NSLayoutConstraint.Axis.vertical
            stackView_programa_proximo.distribution  = UIStackView.Distribution.equalSpacing
            stackView_programa_proximo.alignment = UIStackView.Alignment.top
            
            stackView_programa_proximo.addArrangedSubview(programa_proximo)
            stackView_programa_proximo.addArrangedSubview(programa_proximo_nombre)
            stackView_programa_proximo.translatesAutoresizingMaskIntoConstraints = false
            
            
            programacion_titulos_proximo.addSubview(stackView_programa_proximo )
        } else {
            // Fallback on earlier versions
            print("No soporta stackView_programa_proximo ")
        }
        
        
        
        
        programa_horario_inicio = UILabel(frame: CGRect(x: 300,  y: 15, width:  50, height:  20))
        programa_horario_inicio.text  = "15:00"
        programa_horario_inicio.textColor = .gray
        programa_horario_inicio.textAlignment = .left
        programa_horario_inicio.font = UIFont.boldSystemFont(ofSize: 15.0)
        
        let programa_horario_progressBar = UIView(frame: CGRect(x: programa_horario_inicio.frame.maxX - 30 ,  y: 25, width:  1, height: 1))
        self.progressBar = UIProgressView(progressViewStyle: .bar)
        
       // self.progressBar.frame = CGRect(x:0, y:0 ,width: 20 , height: 1); //width : es longitud total de la barra
        self.progressBar.transform = CGAffineTransform(scaleX: 0.6, y: 5.0) //scaleX : es longitud total de la barra , y: es el ancho total de la barra
        self.progressBar.setProgress(0.3, animated: true)
        self.progressBar.backgroundColor = UIColor.gray
        progressBar.layer.cornerRadius = 8
        progressBar.clipsToBounds = true
        
        let gradientLayer2 = CAGradientLayer()
        gradientLayer2.cornerRadius = 8 // change this number to get the corners you want
        gradientLayer2.masksToBounds = true
        gradientLayer2.frame = CGRect(x:0, y:0 ,width:  570 , height: 80)
        gradientLayer2.colors = [UIColor.blue.cgColor, UIColor.cyan.cgColor]
        gradientLayer2.startPoint = CGPoint(x: 0.0, y: 0.5)
        gradientLayer2.endPoint = CGPoint(x: 1.0, y: 0.5)
        UIGraphicsBeginImageContext(gradientLayer.bounds.size)
        gradientLayer2.render(in: UIGraphicsGetCurrentContext()!)
        let image = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        
        self.progressBar.progressImage = image
        
         
        programa_horario_progressBar.addSubview(self.progressBar)
        
        
        
        
          programa_horario_fin = UILabel( frame: CGRect(x: 450, y: 15, width: 50, height: 20))
        programa_horario_fin.text  = "17:00"
        programa_horario_fin.textColor = .gray
        programa_horario_fin.textAlignment = .right
        programa_horario_fin.font = UIFont.boldSystemFont(ofSize: 15.0)
        
        
        let btnCloseInfoEPG = UIButton( frame: CGRect(x:  520 ,  y: 20, width: 30, height: 30))
        btnCloseInfoEPG.addTarget(self, action: #selector(btnCloseEPGClicked), for: .touchUpInside)
        btnCloseInfoEPG.setTitle("ic_close", for: .normal)
        btnCloseInfoEPG.imageView?.contentMode = .scaleAspectFill
        
        viewBottomEPG = UIView(frame: CGRect(x: ( self.view.frame.width  / 4.4) ,  y: 220, width: ( self.view.frame.width  / 1.8) , height:  (self.view.frame.maxY/4)))
        viewBottomEPG.backgroundColor = UIColor(red: 0.0, green: 0.0, blue:0.0, alpha:  0.7)
        
        self.descripcion_canal = UILabel( frame: CGRect(x: 0, y: 0, width:  viewBottomEPG.frame.width   , height: (self.view.frame.maxY/4)))
        descripcion_canal.text  = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquid ex ea commodi consequat."
        descripcion_canal.textColor = .white
        descripcion_canal.numberOfLines = 3
        descripcion_canal.lineBreakMode = .byWordWrapping
        descripcion_canal.textAlignment = .left
        descripcion_canal.font = UIFont.boldSystemFont(ofSize: 12.0)
  
        viewBottomEPG.addSubview(descripcion_canal)
        
        
          
        viewTopEPG.isHidden = true
        viewTopEPG.layer.insertSublayer(gradientLayer, at:0)
        viewTopEPG.addSubview(caja_cuadrada_componente_numero_canal )
        viewTopEPG.addSubview(caja_cuadrada_componente_imagen_canal )
        viewTopEPG.addSubview(programacion_titulos_actual )
        viewTopEPG.addSubview(programacion_titulos_proximo )
        viewTopEPG.addSubview(programa_horario_inicio )
        viewTopEPG.addSubview(programa_horario_progressBar )
        viewTopEPG.addSubview(programa_horario_fin )
        viewTopEPG.addSubview(btnCloseInfoEPG )
        
        viewBottomEPG.isHidden = true
        
        self.view.addSubview(viewTopEPG)
        self.view.addSubview(viewBottomEPG)
        
        
        
        btnClose.frame = CGRect(x: (self.view.frame.maxX/10), y: (self.view.frame.maxY/14), width: 40, height: 40)
        btnClose.addTarget(self, action: #selector(closePlayer), for: .touchUpInside)
        btnNext.setTitle("ic_close", for: .normal)
        
        
        //MARK: button airplay
        // let frame = CGRect(x: self.view.frame.maxX/1.2, y: self.view.frame.maxY/10, width: 100, height: 50)
        //  routePickerView = AVRoutePickerView(frame: frame)
        // routePickerView.backgroundColor = UIColor.clear
        // let label = UILabel(frame: routePickerView.bounds)
        // label.textColor = .white
        // routePickerView.addSubview(label)
        // label.text = "Airplay"
        
        
        btnInfoEPG.frame = CGRect(x: (self.view.frame.maxX/1.2), y: (self.view.frame.maxY/14), width: 40, height: 40)
        btnInfoEPG.addTarget(self, action: #selector(btnInfoEPGClicked), for: .touchUpInside) 
        btnInfoEPG.setTitle("info", for: .normal)
        btnClose.imageView?.contentMode = .scaleAspectFill
        
        
        btnPreview.frame = CGRect(x: (self.view.frame.maxX/10), y: (self.view.frame.maxY/1.3), width: 40, height: 40)
        btnPreview.addTarget(self, action: #selector(btnPreviewVideoClicked), for: .touchUpInside)
        btnPreview.setTitle("ic_previous", for: .normal)
        btnClose.imageView?.contentMode = .scaleAspectFill
        
        
        btnNext.frame = CGRect(x: (self.view.frame.maxX/1.2),  y: (self.view.frame.maxY/1.3), width: 40, height: 40)
        btnNext.addTarget(self, action: #selector(btnNextVideoClicked), for: .touchUpInside)
        btnNext.setTitle("ic_next", for: .normal)
        btnClose.imageView?.contentMode = .scaleAspectFill
        
        let gesture = UITapGestureRecognizer(target: self, action:  #selector(self.checkAction))
        
        self.view.addGestureRecognizer(gesture)
        self.view.addSubview(btnNext)
        self.view.addSubview(btnInfoEPG)
        self.view.addSubview(btnPreview)
        self.view.addSubview(btnClose)
     
        //self.view.addSubview(routePickerView)
        
    }
    
    // MARK: metodos de botones del reproductor
    @objc func checkAction(sender : UITapGestureRecognizer) {
        print("touch view gesture")
        if(viewBottomEPG.isHidden){
            self.btnClose.isHidden = true
            self.btnNext.isHidden = false
            self.btnInfoEPG.isHidden = true
            self.btnPreview.isHidden = false
            // self.routePickerView.isHidden = false
            self.showControls()
        }
        
    }
    
    @objc  func btnCloseEPGClicked(_ sender: UIButton) {
        print("btnCloseEPGClicked")
        self.viewTopEPG.isHidden = true
        self.viewBottomEPG.isHidden = true
        self.btnClose.isHidden = false
        self.btnInfoEPG.isHidden = false
    }
    
    @objc  func btnInfoEPGClicked(_ sender: UIButton) {
        print("btnInfoEPGClicked")
        self.viewTopEPG.isHidden = false
        self.viewBottomEPG.isHidden = false
        self.btnClose.isHidden = true
        self.btnInfoEPG.isHidden = true
        self.mostrarInfoEPG()
         
        
    }
    func mostrarInfoEPG(){
        
        let canal:VideoModel = listCanales[self.playVideoIndex]
        print(canal.titulo)
        
        self.txtNumeroCanal.text = String(canal.numeroCanal)
        
        let url_imagen_canal = URL(string: canal.imagenPath)
        if let data = try? Data(contentsOf: url_imagen_canal!)
        {
            let image: UIImage = UIImage(data: data)!
            self.imagen_canal.image = image;
        }else{
            print("error SSL imagen ")
        }
        
        
        
        let url = URL(string: "https://api.npoint.io/03dab8c69a2a5825e9bb")!
        
        let task = URLSession.shared.dataTask(with: url) {(data, response, error) in
            guard let data = data else { return }
            
            /*  let jsonDecoder = JSONDecoder()
             let jsonCatalogs = try? jsonDecoder.decode(Array<EPGmodel>.self,from: data)
             print(jsonCatalogs)
             
             */
            if let programacion_json = try? JSONSerialization.jsonObject(with: data, options: [])  as? [String: Any]
            {
                
                guard let programaciones = programacion_json["epg"] as? [[String:Any]] else { return }
                
                
                for programacion in programaciones{
                    
                    let run =   (programacion["run"]  as AnyObject? as? Int) ?? 0
                    let desc = programacion["desc"] as? String ?? ""
                    let titulo = programacion["titulo"] as? String ?? ""
                    let fechaIni = programacion["fecha_ini"] as? Double ??  0.0
                    let fechaFin = programacion["fecha_fin"] as? Double ??  0.0
                    
                    let epg: Epg! = Epg(run: run, desc: desc, titulo: titulo, fechaFin: fechaFin, fechaIni: fechaIni)
                    self.list.append(epg)
                }
                
                var programa_actual_list:Array<Epg> = []
                for item in self.list{
                    let now = Date()
                    let fechaIni  = Date(timeIntervalSince1970: item.fechaIni)
                    
                    
                    let timeNow = 60*Calendar.current.component(.hour, from: now) + Calendar.current.component(.minute, from: now)
                    let timeFechaIni =  60*Calendar.current.component(.hour, from: fechaIni) + Calendar.current.component(.minute, from: fechaIni)
                    
                    if( timeFechaIni  <= timeNow){
                        programa_actual_list.append(item)
                    }
                    
                }
                
                if(true){
                    
                    DispatchQueue.main.async {
                        
                        let programa_actual:Epg = programa_actual_list.last!
                        
                      
                        
                        let x  =  self.list.firstIndex { (item) -> Bool in
                            return item.titulo.contains(programa_actual.titulo)
                        }
                        
                        let valor2 = x!+1
                        let programa_siguiente:Epg = self.list[valor2]
                        
                        let startDate =   Date(timeIntervalSince1970: programa_actual.fechaIni)
                        let endDate =  Date(timeIntervalSince1970: programa_actual.fechaFin)
                        let now = Date()
                         
                        let dayTimePeriodFormatter = DateFormatter()
                        dayTimePeriodFormatter.dateFormat = "HH:mm:ss"
                        let startDateString = dayTimePeriodFormatter.string(from: startDate)
                        let endDateString = dayTimePeriodFormatter.string(from: endDate)
                        let nowDateString = dayTimePeriodFormatter.string(from: now)
                         
                        let formatter2 = DateFormatter()
                        formatter2.dateFormat = "yyyy-MM-dd"
                        let someDateTime = formatter2.string(from: now)
                        
                        
                        let string_startDateString = someDateTime+" "+startDateString
                        let string_endDateString = someDateTime+" "+endDateString
                        let string_nowDateString = someDateTime+" "+nowDateString
                       
                        let formatter = DateFormatter()
                        formatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
                       /*  let startDate1 = formatter.date(from: string_startDateString)!.timeIntervalSince1970
                        let endDate1 = formatter.date(from: string_endDateString)!.timeIntervalSince1970
                        let currentDate1 = formatter.date(from: string_nowDateString)!.timeIntervalSince1970
                      
                        
                        let percentage1 = (currentDate1 - startDate1) / (endDate1 - startDate1)
                           */
                        
                        let startDate2 = formatter.date(from: string_startDateString)!
                        let duration2 = formatter.date(from: string_endDateString)!.timeIntervalSince(startDate2)
                        let elapsed2 = formatter.date(from: string_nowDateString)!.timeIntervalSince(startDate2)
                        
                        let percentage2:Float = Float( elapsed2 / duration2 )
                        
                        
                        self.progressBar.setProgress(percentage2, animated: true)
                         
                        
                        let strDate_hora_inicio = self.getDateFromTimeStamp(timeStamp: programa_actual.fechaIni)
                        
                        let strDate_hora_fin = self.getDateFromTimeStamp(timeStamp: programa_actual.fechaFin)
                        
                        
                        self.programa_actual_nombre.text = programa_actual.titulo
                        self.programa_proximo_nombre.text = programa_siguiente.titulo
                        self.programa_horario_inicio.text = strDate_hora_inicio
                        self.programa_horario_fin.text = strDate_hora_fin
                    }
                }
            }
            
            
        }
        
        task.resume()
    }
    func getDateFromTimeStamp(timeStamp : Double) -> String {
        
        let date = NSDate(timeIntervalSince1970: timeStamp)
        
        let dayTimePeriodFormatter = DateFormatter()
         // dayTimePeriodFormatter.dateFormat = "dd MMM YY, hh:mm a"
        // UnComment below to get only time
        dayTimePeriodFormatter.dateFormat = "hh:mm"
        
        let dateString = dayTimePeriodFormatter.string(from: date as Date)
        return dateString
    }
     
    
    @objc func btnNextVideoClicked(sender: UIButton!) {
        self.playVideoIndex+=1
        
        if(self.playVideoIndex >= listCanales.count){
           self.playVideoIndex = 0
            
            player?.removeAllItems()
            
            let item : VideoModel = listCanales[playVideoIndex]
            let url = URL(string: item.linkReproductor)
            let newItem = AVPlayerItem(url: url!)
            self.player?.replaceCurrentItem(with: newItem)
            
        }else{
            player?.removeAllItems()
            
            let item : VideoModel = listCanales[playVideoIndex]
            let url = URL(string: item.linkReproductor)
            let newItem = AVPlayerItem(url: url!)
            self.player?.replaceCurrentItem(with: newItem)
            
        }
        self.showControls()
        self.mostrarInfoEPG()
        self.progressBar.setProgress(0.40, animated: true)
    }
    
    @objc func btnPreviewVideoClicked(_ sender: UIButton) {
        
        self.progressBar.setProgress(1.0, animated: true)
        if(self.playVideoIndex  == 0){
            self.playVideoIndex = listCanales.count
        }
        self.playVideoIndex =  self.playVideoIndex - 1
        player?.removeAllItems()
        let item : VideoModel = listCanales[playVideoIndex]
        let url = URL(string: item.linkReproductor)
        let newItem = AVPlayerItem(url: url!)
        self.player?.replaceCurrentItem(with: newItem)
        
        self.showControls()
        self.mostrarInfoEPG()
        
    }
    @objc func closePlayer(_ sender: UIButton) {
        print("closePlayer")
        self.dismiss(animated: true, completion: nil)
        let value = UIInterfaceOrientation.portrait.rawValue
        UIDevice.current.setValue(value, forKey: "orientation")
        
    }
    
    private func showControls(){
        
        delayWithSeconds(7) {
            
            self.btnClose.isHidden = true
            self.btnInfoEPG.isHidden = true
            // self.routePickerView.isHidden = true
            
        }
    }
    public func getCurrentLink() -> String{
        
        let url: URL? = (player?.currentItem?.asset as? AVURLAsset)?.url
        
        return url!.absoluteString
    }
    
    // MARK: para detectar cambio de pantalla y establecer landscape left o right
    override func willRotate(to toInterfaceOrientation: UIInterfaceOrientation, duration: TimeInterval) {
        
        var text=""
        switch UIDevice.current.orientation{
            case .portrait:
                text="Portrait"
            case .portraitUpsideDown:
                text="PortraitUpsideDown"
            case .landscapeLeft:
                text="LandscapeLeft"
            case .landscapeRight:
                text="LandscapeRight"
            default:
                text="Another"
        }
        print("You have moved1: \(text)")
        
    }
    override func didRotate(from fromInterfaceOrientation: UIInterfaceOrientation) {
        var text=""
        switch UIDevice.current.orientation{
            case .portrait:
                text="Portrait"
            case .portraitUpsideDown:
                text="PortraitUpsideDown"
            case .landscapeLeft:
                text="LandscapeLeft"
            case .landscapeRight:
                text="LandscapeRight"
            default:
                text="Another"
        }
        print("You have moved3: \(text)")
    }
    //    override public var shouldAutorotate: Bool {
    //           return true
    //       }
    //    override public var supportedInterfaceOrientations: UIInterfaceOrientationMask {
    //
    //            if UIDevice.current.orientation == .landscapeLeft{
    //
    //                          print("landscapeLeft3")
    //                           self.isLandscapeLeft = .landscapeLeft
    //                      }
    //                      else  if UIDevice.current.orientation == .landscapeRight{
    //                          self.isLandscapeLeft = .landscapeRight
    //
    //           print("landscapeLeft333")
    //
    //                      }
    //
    //           let orientation: UIInterfaceOrientationMask = [UIInterfaceOrientationMask.landscape, UIInterfaceOrientationMask.landscapeRight]
    //              return orientation
    //       }
    //    override public var preferredInterfaceOrientationForPresentation: UIInterfaceOrientation {
    //
    //           return   self.isLandscapeLeft  ;
    //       }
    
    // MARK: Utilidades
    
    
    
    private func getTimeString(from time: CMTime) -> String {
        let totalSeconds = CMTimeGetSeconds(time)
        let hours = Int(totalSeconds/3600)
        let minutes = Int(totalSeconds/60) % 60
        let seconds = Int(totalSeconds.truncatingRemainder(dividingBy: 60))
        if hours > 0 {
            return String(format: "%i:%02i:%02i", arguments: [hours,minutes,seconds])
        }else {
            return String(format: "%02i:%02i", arguments: [minutes,seconds])
        }
    }
    private func delayWithSeconds(_ seconds: Double, completion: @escaping () -> ()) {
        DispatchQueue.main.asyncAfter(deadline: .now() + seconds) {
            completion()
        }
    }
    private func showActivityIndicatory() {
        let container: UIView = UIView()
        container.frame = CGRect(x: 0, y: 0, width: 80, height: 80) // Set X and Y whatever you want
        container.backgroundColor = .clear
        
        self.activityView = UIActivityIndicatorView(style: .whiteLarge)
        self.activityView?.center = self.view.center
        
        container.addSubview(self.activityView!)
        self.view.addSubview(container)
        self.activityView!.startAnimating()
    }
}
