import Flutter

import UIKit
import AVFoundation
import Foundation
import AVKit

@available(iOS 9.0, *)
public class SwiftHlsPlayerPlugin: UIViewController, FlutterPlugin {

   let AVPlayerZapping : ViewController_AVPlayer_List = ViewController_AVPlayer_List() ;

  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "hls_player", binaryMessenger: registrar.messenger())
    let instance = SwiftHlsPlayerPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {

        switch call.method {
                            case "initializeVideo":
                            
                                  guard let args = call.arguments else {
                                          result("iOS could not recognize flutter arguments in method: ( \(call.method))") 
                                          return
                                        }

                                      if let myArgs = args as? [String: String],
                                          let url = myArgs["url"] {

                                            
                                                  //Present your ViewController only if its not present to the user currently.
                                                  let AVPlayerVideo : ViewController_AVPlayer_Video = ViewController_AVPlayer_Video() ;
                                                  AVPlayerVideo.isBuild( url, userCompletionHandler: {mensaje, error in
           
                result(mensaje) 
        })
                                        } else {
                                          result(FlutterError(code: "-1", message: "iOS could not extract " + 
                                            "flutter arguments 'url' in method: ( \(call.method))", details: nil))
                                        } 
                break;


               case "initializeZapping":
        
                                      guard let args = call.arguments else {
                                      result("iOS could not recognize flutter arguments in method: ( \(call.method))") 
                                      return
                                    }
                                                      
                                if let myArgs = args as? [String: Any],
                                      let canales = myArgs["canales"] as? String ,
                                      let playVideoAtIndex = myArgs["playVideoAtIndex"] as? Int {


                                        //let AVPlayerZapping : ViewController_AVPlayer_List = ViewController_AVPlayer_List() ;
                                        
                                        self.AVPlayerZapping.playVideoIndex = playVideoAtIndex

      AVPlayerZapping.jsonCanales = canales

                                        DispatchQueue.main.async { UIApplication.shared.keyWindow?.rootViewController?.present(self.AVPlayerZapping, animated: true, completion: nil);  }
                                                  
                                                  
                                                      // if( AVPlayerZapping.isBeingPresented) {

                                                      //     result(canales)
                                                      // }else{
                                                      //     result(FlutterError(code: "-1", message: "No fue abierto el Controlador \(call.method)", details: nil))
                                                      // }

                                                          result(canales)
                                                        
                                  } else {
                                          result(FlutterError(code: "-1", message: "iOS could not extract " + 
                                            "flutter arguments 'canales' in method: ( \(call.method))", details: nil))
                                  }
 

                        break;


               case "getVideoLink":
        
                              

                             
 

                                                          result(self.AVPlayerZapping.getCurrentLink())
                                                        
                            
 
                        break;
          default:
              result(FlutterMethodNotImplemented)
                
        }
      
       
    }
        


  



}
 
